<form on:submit|preventDefault={() => {}} bind:this={ formEl }>
    {#each items as {type, options, value, ...fieldProps}}
        {#if type === 'input'}
            <input type="text" {...fieldProps} bind:value/>
        {:else if type === 'select'}
            <!-- 
                The select input is different in svelte.
                For some reason option tag don't allow spreading value
                and the selected is defined in select tag
            -->
            <select bind:value {...fieldProps}>
                {#each options as {label, value, ...optionsAttrs} }
                    <option {...optionsAttrs} { value }>
                        { label }
                    </option>
                {/each}
            </select>
        {/if}
    {/each}
</form>

<script lang="ts">
    import { createEventDispatcher } from 'svelte'
    const dispatch = createEventDispatcher()
    
    /**
     * List all items that form will display.
     * You can bind this to catch the values
     */
    export let items

    let formEl

    /**
     * using this notation the storybook will not identify the event
     * you have to define him on the stories file
    */
    $: dispatch('change', { items })

    /**
     * External function to get form data.
     * You can use instead the bind:items or the on:change event
     * to react to the modifications
     * @param { 'formdata' | 'object' } type
     * @returns { FormData | object }
     */
    export function getData(type) {
        if (!formEl) return {}
        const formData = new FormData(formEl)

        if (type === 'formdata') return formData

        return Object.fromEntries(formData)
    }
</script>